public class BinaryInsertionSortTest
{

	public static void binaryInsertionSort(double[] data)
	    {
		for (int i=1; i<data.length; i++)
		{
		    double temp = data[i]; // value to be inserted into
		                           // "left side" of array
		    int j,left=0,right=i;

		    while (left<right)     // binary search
		    {
				int middle = (left+right)/2;
				if (data[middle]<=temp)
					left=middle+1;
				else
					right = middle;
		    }

		    j = right; // insertion index

		    if (j<i)  // shift up intervening array elements
		        for (int k=i-1; k>=j; k--)
				    data[k+1] = data[k];
		    data[j] = temp;
		    System.out.println(temp);
		    print_array(data);
		}
    }


    public static void main(String[] args)
    {
		double[] data = {5.0, 0.0, -2.3, -0.3, -7.0, 1.2};

		System.out.println("Data array: ");
		print_array(data);

		binaryInsertionSort(data);

		System.out.println("Sorted data array");
		print_array(data);

    }

    public static void print_array(double[] d)
    {
		for (int i=0; i < d.length; i++)
			System.out.print(d[i] + " ");
		System.out.println();
	}
}